# ----------------------------------------------------------------------------------------------------------
# autor: Dominik Vladar
# orion login: vladar21
# e-mail: vladar21@students.zcu.cz
#
# Program nalezne pocet cisel na intervalu <1, 1000>, ktere je mozne vyjadrit jako soucet tri druhych mocnin
# prirozenych cisel (zadani z 1. cviceni, ukol 23).
# ----------------------------------------------------------------------------------------------------------

import math


# Funkce nalezne pocet cisel na intervalu <1, max_value>, ktere je mozne vyjadrit
# jako soucet tri druhych mocnin prirozenych cisel. Pokud je navic parametr different_only nastaven na True, musi
# tato tri prirozena cisla byt navzajem ruzna. Pocet nalezenych cisel vraci funkce navratovou hodnotou.
def calculate(max_value, different_only):
    squares = []
    valid_numbers = {}
    additional = 1 if different_only else 0

    for i in range(1, int(math.sqrt(max_value))+1):
        squares.append(i**2)
    for i in range(0, len(squares)):
        total = squares[i]
        if 3*total >= max_value:
            break
        for j in range(i+additional, len(squares)):
            j_square = squares[j]
            if total+2*j_square >= max_value:
                break
            j_total = total + j_square
            for k in range(j+additional, len(squares)):
                k_square = squares[k]
                k_total = j_total + k_square
                if k_total >= max_value:
                    break
                valid_numbers[k_total] = True
    return len(valid_numbers.keys())


# Spusteni programu. Zde se definuji konstanty pro vypocet a nasledne je volana funkce calculate,
# ktera se postara o vyreseni ulohy.
if __name__ == '__main__':
    max_num = 1000
    different_numbers_only = False
    number_count = calculate(max_num, different_numbers_only)
    print("Bylo nalezeno {} cisel od 1 do {}, ktere je mozne vyjadrit jako soucet tri {}druhych mocnin prirozenych cisel."
          .format(number_count, max_num, "ruznych " if different_numbers_only else ""))
    input("Ukoncete stiskem klavesy ENTER.")
