# ---------------------------------------------------------------------------
# Autor: Lukas Sobotka
# Datum: 28. 10. 20223
# Verze: 1.0
# Zadani: Realizujte program v Pythonu, jimz budete modelovat a na obrazovce dokumentovat
#         provadeni zakladnich mnozinovych operaci (typy a velikost mnozin volte podle uvazeni)
# ---------------------------------------------------------------------------
# Program vytvori nove okno a umozni uzivateli zadavat mnoziny a provadet s nimi zakladni mnozinove operace

# knihovna pro uzivatelske rozhrani
import tkinter as tk

# messagebox je pouzivan na zobrazeni error zprav pri neplatnem vstupu uzivatele
from tkinter import messagebox


# Otevre podokno s moznosti pridani prvku do mnoziny
def pridani_prvku_mnoziny():
    # Prida prvek zadany uzivatelem do zadane mnoziny nebo zobrazi messagebox s chybovou zpravou
    def pridani_prvku():
        try:
            mnozina = mnoziny[int(entry_mnozina.get()) - 1]
            mnozina.add(entry_prvek.get())

            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Pridani do mnoziny")
    entry_mnozina = napln_podokno(nove_okno, "Zadej cislo mnoziny, do ktere chcete pridat prvek:", "Pridej",
                                  pridani_prvku)

    text = tk.Label(nove_okno, text="Zadejte prvek, ktery chcete pridat", font=("Helvetica", 12))
    text.grid(row=3, columnspan=2)

    entry_prvek = tk.Entry(nove_okno, font=("Helvetica", 12))
    entry_prvek.grid(row=4, columnspan=2)


# Otevre podokno s moznosti odebrani prvku z mnoziny
def odebrani_prvku_mnoziny():
    # Odebere prvek zadany uzivatelem ze zadane mnoziny nebo zobrazi messagebox s chybovou zpravou
    def odebrani_prvku():
        try:
            mnozina = mnoziny[int(entry_mnozina.get()) - 1]
            mnozina.remove(entry_prvek.get())

            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Odebrani z mnoziny")
    entry_mnozina = napln_podokno(nove_okno, "Zadej cislo mnoziny, ze ktere chcete odebrat prvek:", "Odeber",
                                  odebrani_prvku)

    text = tk.Label(nove_okno, text="Zadejte prvek, ktery chcete odebrat", font=("Helvetica", 12))
    text.grid(row=3, columnspan=2)

    entry_prvek = tk.Entry(nove_okno, font=("Helvetica", 12))
    entry_prvek.grid(row=4, columnspan=2)


# Otevre podokno s moznosti pruniku dvou mnozin, vysledek pruniku bude pridan jako nova mnozina
def symetricky_rozdil_mnozin():
    # Prida do seznamu mnozin mnozinu vzniklou symetrickym rozdilem zadanych mnozin nebo zobrazi chybovou zpravu
    def symetricky_rozdil():
        try:
            temp = entry.get().split()
            mnoz1 = mnoziny[int(temp[0]) - 1]
            mnoz2 = mnoziny[int(temp[1]) - 1]

            mnoziny.append(mnoz1.symmetric_difference(mnoz2))
            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno(" Symetricky rozdil mnozin")
    entry = napln_podokno(nove_okno, "Zadejte cisla dvou mnozin oddelana mezernikem:",
                          "Symetricky rozdil", symetricky_rozdil)


# Otevre podokno s moznosti rozdilu dvou mnozin, vysledek rozdilu bude pridan jako nova mnozina
def rozdil_mnozin():
    # Prida do seznamu mnozin mnozinu vzniklou rozdilem zadanych mnozin nebo zobrazi messagebox s chybovou zpravou
    def rozdil():
        try:
            temp = entry.get().split()
            mnoz1 = mnoziny[int(temp[0]) - 1]
            mnoz2 = mnoziny[int(temp[1]) - 1]

            mnoziny.append(mnoz1.difference(mnoz2))
            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Rozdil mnozin")
    entry = napln_podokno(nove_okno, "Zadejte cisla dvou mnozin oddelana mezernikem:", "Rozdil", rozdil)


# Otevre podokno s moznosti pruniku dvou mnozin, vysledek pruniku bude pridan jako nova mnozina
def prunik_mnozin():
    # Prida do seznamu mnozin mnozinu vzniklou prunikem zadanych mnozin nebo zobrazi messagebox s chybovou zpravou
    def prunik():
        try:
            temp = entry.get().split()
            mnoz1 = mnoziny[int(temp[0]) - 1]
            mnoz2 = mnoziny[int(temp[1]) - 1]

            mnoziny.append(mnoz1.intersection(mnoz2))
            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Prunik mnozin")
    entry = napln_podokno(nove_okno, "Zadejte cisla dvou mnozin oddelana mezernikem:", "Prunik", prunik)


# Otevre podokno s moznosti spojeni dvou mnozin, vysledek spojeni bude pridan jako nova mnozina
def spojeni_mnozin():
    # Prida do seznamu mnozin mnozinu vzniklou spojenim zadanych mnozin nebo zobrazi messagebox s chybovou zpravou
    def spojeni():
        try:
            temp = entry.get().split()
            mnoz1 = mnoziny[int(temp[0]) - 1]
            mnoz2 = mnoziny[int(temp[1]) - 1]

            mnoziny.append(mnoz1.union(mnoz2))
            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Spojeni mnozin")
    entry = napln_podokno(nove_okno, "Zadejte cisla dvou mnozin oddelana mezernikem:", "Spojeni", spojeni)


# Otevre podokno s moznosti pridani nove mnoziny
def pridat_mnozinu():
    # Prida mnozinu zadanou uzivatelem do seznamu mnozin
    def pridat():
        zadana_mnozina = set(entry.get().split())  # Z uzivatelskeho vstupu vytvori mnozinu
        mnoziny.append(zadana_mnozina)  # prida mnozinu do seznamu mnozin
        zobraz_mnoziny()
        nove_okno.destroy()

    nove_okno = podokno("Pridani mnoziny")
    entry = napln_podokno(nove_okno, "Vypiste prvky mnoziny oddelene mezernikem:", "Pridej", pridat)


# Otevre podokno s moznosti odstraneni mnoziny
def odstranit_mnozinu():
    # Odebere ze setnamu mnozin mnozinu zadanou uzivatelem nebo zobrazi messagebox s chybovou zpravou
    def odstranit():
        try:
            mnoziny.pop(int(entry.get()) - 1)
            zobraz_mnoziny()
            nove_okno.destroy()
        except:
            messagebox.showerror("Operaci nelze provest")

    nove_okno = podokno("Ostraneni mnoziny")
    entry = napln_podokno(nove_okno, "Napis cislo mnoziny k odstraneni:", "Odstranit", odstranit)


# Vytvori a vrati nove podokno
# nazev - nazev noveho podokna
# return - nove vytvorene podokno
def podokno(nazev):
    nove_okno = tk.Toplevel(okno)
    nove_okno.title(nazev)
    nove_okno.transient(okno)  # Nastavi nove okno jako podokno puvodniho okna
    nove_okno.grab_set()  # Uzamkneme puvodni okno dokud nebude zavreno podokno
    return nove_okno


# Naplni nove podokno labelem, vstupnim polem, tlacitkem zruseni a tlacitkem potvrzeni
# nove_okno - okno, do ktereho budou widgety vkladany
# text - text, ktery bude vlozen do labelu
# text_tlacitka - text, ktery bude na tlacitku potvrzeni
# funkce - funkce, ktera bude provedena po zmacknuti tlacitka potvrzeni
# return - vstupni pole
def napln_podokno(nove_okno, text, text_tlacitka, funkce):
    tlacitko_zrusit = tk.Button(nove_okno, text="Zrusit", command=nove_okno.destroy)
    tlacitko_zrusit.grid(column=0, row=6)

    label = tk.Label(nove_okno, text=text, font=("Helvetica", 12))
    label.grid(row=1, columnspan=2)

    entry = tk.Entry(nove_okno, font=("Helvetica", 12))
    entry.grid(row=2, columnspan=2)
    entry.focus_set()

    tlacitko_ok = tk.Button(nove_okno, text=text_tlacitka, command=funkce)
    tlacitko_ok.grid(column=1, row=6)

    # Klavesa ENTER zmackne talcitko potvrzeni
    nove_okno.bind('<Return>', lambda event=None: tlacitko_ok.invoke())
    return entry


# Vsechny mnoziny z promenne "mnoziny" vypise do textoveho pole
def zobraz_mnoziny():
    textove_pole.config(state=tk.NORMAL)  # Povoleni upravy textoveho pole
    textove_pole.delete(1.0, tk.END)  # Smazani celeho pole
    for idx, mnozina in enumerate(mnoziny, start=1):
        if mnozina:
            textove_pole.insert(tk.END, f"{idx}: {str(mnozina)}\n")
        else:
            textove_pole.insert(tk.END, f"{idx}: " + "{}\n")
    textove_pole.config(state=tk.DISABLED)  # Zakazani upravy textoveho pole


# Vytvoreni okna
okno = tk.Tk()
okno.title("Set Display")

# Vytvoreni nadpisu
nadpis = tk.Label(okno, text="Vizualizace mnozinovych operaci", font=("Helvetica", 12))
nadpis.grid(row=2, column=0, columnspan=4)

# Vytvoreni textoveho pole pro zobrazeni mnozin
textove_pole = tk.Text(okno, height=10, width=40, font=("Helvetica", 12))
textove_pole.grid(row=2, column=0, columnspan=4)

# Vytvoreni tlacitek
tlacitko_pridej = tk.Button(okno, text="Pridat", command=pridat_mnozinu)
tlacitko_pridej.grid(row=0, column=0)

tlacitko_odstran = tk.Button(okno, text="Odstranit", command=odstranit_mnozinu)
tlacitko_odstran.grid(row=0, column=1)

tlacitko_spojeni = tk.Button(okno, text="Spojeni", command=spojeni_mnozin)
tlacitko_spojeni.grid(row=0, column=2)

tlacitko_pruniku = tk.Button(okno, text="Prunik", command=prunik_mnozin)
tlacitko_pruniku.grid(row=0, column=3)

tlacitko_rozdilu = tk.Button(okno, text="Rozdil", command=rozdil_mnozin)
tlacitko_rozdilu.grid(row=1, column=0)

tlacitko_symetrickeho_rozdilu = tk.Button(okno, text="Sym. Rozdil", command=symetricky_rozdil_mnozin)
tlacitko_symetrickeho_rozdilu.grid(row=1, column=1)

tlacitko_pridani_prvku = tk.Button(okno, text="Pridat prvek", command=pridani_prvku_mnoziny)
tlacitko_pridani_prvku.grid(row=1, column=2)

tlacitko_odebrani_prvku = tk.Button(okno, text="Odebrat prvek", command=odebrani_prvku_mnoziny)
tlacitko_odebrani_prvku.grid(row=1, column=3)

mnoziny = []  # pole vsech vytvorenych mnozin

okno.mainloop()
